// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from open_sound_control_msgs:msg/OscBlob.idl
// generated code does not contain a copyright notice
#include "open_sound_control_msgs/msg/detail/osc_blob__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `data`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
open_sound_control_msgs__msg__OscBlob__init(open_sound_control_msgs__msg__OscBlob * msg)
{
  if (!msg) {
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->data, 0)) {
    open_sound_control_msgs__msg__OscBlob__fini(msg);
    return false;
  }
  return true;
}

void
open_sound_control_msgs__msg__OscBlob__fini(open_sound_control_msgs__msg__OscBlob * msg)
{
  if (!msg) {
    return;
  }
  // data
  rosidl_runtime_c__uint8__Sequence__fini(&msg->data);
}

bool
open_sound_control_msgs__msg__OscBlob__are_equal(const open_sound_control_msgs__msg__OscBlob * lhs, const open_sound_control_msgs__msg__OscBlob * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  return true;
}

bool
open_sound_control_msgs__msg__OscBlob__copy(
  const open_sound_control_msgs__msg__OscBlob * input,
  open_sound_control_msgs__msg__OscBlob * output)
{
  if (!input || !output) {
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  return true;
}

open_sound_control_msgs__msg__OscBlob *
open_sound_control_msgs__msg__OscBlob__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  open_sound_control_msgs__msg__OscBlob * msg = (open_sound_control_msgs__msg__OscBlob *)allocator.allocate(sizeof(open_sound_control_msgs__msg__OscBlob), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(open_sound_control_msgs__msg__OscBlob));
  bool success = open_sound_control_msgs__msg__OscBlob__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
open_sound_control_msgs__msg__OscBlob__destroy(open_sound_control_msgs__msg__OscBlob * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    open_sound_control_msgs__msg__OscBlob__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
open_sound_control_msgs__msg__OscBlob__Sequence__init(open_sound_control_msgs__msg__OscBlob__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  open_sound_control_msgs__msg__OscBlob * data = NULL;

  if (size) {
    data = (open_sound_control_msgs__msg__OscBlob *)allocator.zero_allocate(size, sizeof(open_sound_control_msgs__msg__OscBlob), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = open_sound_control_msgs__msg__OscBlob__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        open_sound_control_msgs__msg__OscBlob__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
open_sound_control_msgs__msg__OscBlob__Sequence__fini(open_sound_control_msgs__msg__OscBlob__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      open_sound_control_msgs__msg__OscBlob__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

open_sound_control_msgs__msg__OscBlob__Sequence *
open_sound_control_msgs__msg__OscBlob__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  open_sound_control_msgs__msg__OscBlob__Sequence * array = (open_sound_control_msgs__msg__OscBlob__Sequence *)allocator.allocate(sizeof(open_sound_control_msgs__msg__OscBlob__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = open_sound_control_msgs__msg__OscBlob__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
open_sound_control_msgs__msg__OscBlob__Sequence__destroy(open_sound_control_msgs__msg__OscBlob__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    open_sound_control_msgs__msg__OscBlob__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
open_sound_control_msgs__msg__OscBlob__Sequence__are_equal(const open_sound_control_msgs__msg__OscBlob__Sequence * lhs, const open_sound_control_msgs__msg__OscBlob__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!open_sound_control_msgs__msg__OscBlob__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
open_sound_control_msgs__msg__OscBlob__Sequence__copy(
  const open_sound_control_msgs__msg__OscBlob__Sequence * input,
  open_sound_control_msgs__msg__OscBlob__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(open_sound_control_msgs__msg__OscBlob);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    open_sound_control_msgs__msg__OscBlob * data =
      (open_sound_control_msgs__msg__OscBlob *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!open_sound_control_msgs__msg__OscBlob__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          open_sound_control_msgs__msg__OscBlob__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!open_sound_control_msgs__msg__OscBlob__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
