// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from open_sound_control_msgs:msg/OscMessage.idl
// generated code does not contain a copyright notice

#include "open_sound_control_msgs/msg/detail/osc_message__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_open_sound_control_msgs
const rosidl_type_hash_t *
open_sound_control_msgs__msg__OscMessage__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x39, 0x46, 0xa5, 0xab, 0x31, 0x70, 0x34, 0x09,
      0x14, 0xcc, 0xbe, 0xc0, 0x21, 0xe9, 0x14, 0xb5,
      0x9c, 0xae, 0x31, 0x05, 0x53, 0xc7, 0xa5, 0xa9,
      0xe2, 0x6f, 0x78, 0xa0, 0x09, 0x1a, 0x46, 0x30,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char open_sound_control_msgs__msg__OscMessage__TYPE_NAME[] = "open_sound_control_msgs/msg/OscMessage";

// Define type names, field names, and default values
static char open_sound_control_msgs__msg__OscMessage__FIELD_NAME__address[] = "address";
static char open_sound_control_msgs__msg__OscMessage__FIELD_NAME__types[] = "types";
static char open_sound_control_msgs__msg__OscMessage__FIELD_NAME__payload[] = "payload";

static rosidl_runtime_c__type_description__Field open_sound_control_msgs__msg__OscMessage__FIELDS[] = {
  {
    {open_sound_control_msgs__msg__OscMessage__FIELD_NAME__address, 7, 7},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {open_sound_control_msgs__msg__OscMessage__FIELD_NAME__types, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {open_sound_control_msgs__msg__OscMessage__FIELD_NAME__payload, 7, 7},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
open_sound_control_msgs__msg__OscMessage__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {open_sound_control_msgs__msg__OscMessage__TYPE_NAME, 38, 38},
      {open_sound_control_msgs__msg__OscMessage__FIELDS, 3, 3},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Required OSC 1.1 types:\n"
  "string FLOAT = \"f\"    # IEEE float32\n"
  "string INTEGER = \"i\"  # signed 32-bit integer (most significant byte first)\n"
  "string BLOB = \"b\"     # byte array of length N, where N is represented as a 32-bit integer in the first 4 bytes\n"
  "string STRING = \"s\"   # null-terminated string of 8-bit chars\n"
  "string TIMETAG = \"t\"  # 64-bit OSC timetag in NTP format\n"
  "string IMPULSE = \"I\"  # impulse/trigger; no bytes allocated in payload\n"
  "string NIL = \"N\"      # null; no bytes allocated in payload\n"
  "string B_TRUE = \"T\"   # boolean True; no bytes allocated in payload\n"
  "string B_FALSE = \"F\"  # boolean False; no bytes allocated in payload\n"
  "\n"
  "\n"
  "# Optional additional types\n"
  "string CHAR = \"c\"     # a single 8-bit character (contained in the least-significant byte of a 32-bit integer)\n"
  "string DOUBLE = \"d\"   # IEEE 754 float64\n"
  "string MIDI = \"m\"     # 4-byte MIDI message\n"
  "string RGBA = \"r\"     # 32-bit RGBA colour\n"
  "string SYMBOLS = \"S\"  # alternative data represented as a string; treated interchangeably with \"s\"\n"
  "\n"
  "# Optional data arrays\n"
  "# Array data is not supported in open_sound_control_ros; OSC messages containing\n"
  "# these characters will be ignored\n"
  "string ARR_START = \"[\"\n"
  "string ARR_STOP = \"]\"\n"
  "\n"
  "\n"
  "# The OSC address of the message\n"
  "string address\n"
  "\n"
  "# The OSC v1.1 compatible list of types in the payload\n"
  "# Each character in the string indicates a specific type\n"
  "# See type definitions above\n"
  "string[] types\n"
  "\n"
  "# The payload bytes\n"
  "# Each variable in the payload is word-aligned, meaning there\n"
  "# may be padding bytes between items\n"
  "uint8[] payload";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
open_sound_control_msgs__msg__OscMessage__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {open_sound_control_msgs__msg__OscMessage__TYPE_NAME, 38, 38},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 1534, 1534},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
open_sound_control_msgs__msg__OscMessage__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *open_sound_control_msgs__msg__OscMessage__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
