// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from open_sound_control_msgs:msg/OscMessage.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "open_sound_control_msgs/msg/osc_message.h"


#ifndef OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_MESSAGE__STRUCT_H_
#define OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_MESSAGE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'FLOAT'.
/**
  * IEEE float32
 */
static const char * const open_sound_control_msgs__msg__OscMessage__FLOAT = "f";

/// Constant 'INTEGER'.
/**
  * signed 32-bit integer (most significant byte first)
 */
static const char * const open_sound_control_msgs__msg__OscMessage__INTEGER = "i";

/// Constant 'BLOB'.
/**
  * byte array of length N, where N is represented as a 32-bit integer in the first 4 bytes
 */
static const char * const open_sound_control_msgs__msg__OscMessage__BLOB = "b";

/// Constant 'STRING'.
/**
  * null-terminated string of 8-bit chars
 */
static const char * const open_sound_control_msgs__msg__OscMessage__STRING = "s";

/// Constant 'TIMETAG'.
/**
  * 64-bit OSC timetag in NTP format
 */
static const char * const open_sound_control_msgs__msg__OscMessage__TIMETAG = "t";

/// Constant 'IMPULSE'.
/**
  * impulse/trigger; no bytes allocated in payload
 */
static const char * const open_sound_control_msgs__msg__OscMessage__IMPULSE = "I";

/// Constant 'NIL'.
/**
  * null; no bytes allocated in payload
 */
static const char * const open_sound_control_msgs__msg__OscMessage__NIL = "N";

/// Constant 'B_TRUE'.
/**
  * boolean True; no bytes allocated in payload
 */
static const char * const open_sound_control_msgs__msg__OscMessage__B_TRUE = "T";

/// Constant 'B_FALSE'.
/**
  * boolean False; no bytes allocated in payload
 */
static const char * const open_sound_control_msgs__msg__OscMessage__B_FALSE = "F";

/// Constant 'CHAR'.
/**
  * Optional additional types
  * a single 8-bit character (contained in the least-significant byte of a 32-bit integer)
 */
static const char * const open_sound_control_msgs__msg__OscMessage__CHAR = "c";

/// Constant 'DOUBLE'.
/**
  * IEEE 754 float64
 */
static const char * const open_sound_control_msgs__msg__OscMessage__DOUBLE = "d";

/// Constant 'MIDI'.
/**
  * 4-byte MIDI message
 */
static const char * const open_sound_control_msgs__msg__OscMessage__MIDI = "m";

/// Constant 'RGBA'.
/**
  * 32-bit RGBA colour
 */
static const char * const open_sound_control_msgs__msg__OscMessage__RGBA = "r";

/// Constant 'SYMBOLS'.
/**
  * alternative data represented as a string; treated interchangeably with "s"
 */
static const char * const open_sound_control_msgs__msg__OscMessage__SYMBOLS = "S";

/// Constant 'ARR_START'.
/**
  * Optional data arrays
  * Array data is not supported in open_sound_control_ros; OSC messages containing
  * these characters will be ignored
 */
static const char * const open_sound_control_msgs__msg__OscMessage__ARR_START = "[";

/// Constant 'ARR_STOP'.
static const char * const open_sound_control_msgs__msg__OscMessage__ARR_STOP = "]";

// Include directives for member types
// Member 'address'
// Member 'types'
#include "rosidl_runtime_c/string.h"
// Member 'payload'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/OscMessage in the package open_sound_control_msgs.
/**
  * Required OSC 1.1 types:
 */
typedef struct open_sound_control_msgs__msg__OscMessage
{
  /// The OSC address of the message
  rosidl_runtime_c__String address;
  /// The OSC v1.1 compatible list of types in the payload
  /// Each character in the string indicates a specific type
  /// See type definitions above
  rosidl_runtime_c__String__Sequence types;
  /// The payload bytes
  /// Each variable in the payload is word-aligned, meaning there
  /// may be padding bytes between items
  rosidl_runtime_c__uint8__Sequence payload;
} open_sound_control_msgs__msg__OscMessage;

// Struct for a sequence of open_sound_control_msgs__msg__OscMessage.
typedef struct open_sound_control_msgs__msg__OscMessage__Sequence
{
  open_sound_control_msgs__msg__OscMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} open_sound_control_msgs__msg__OscMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_MESSAGE__STRUCT_H_
