// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from open_sound_control_msgs:msg/OscMessage.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "open_sound_control_msgs/msg/osc_message.hpp"


#ifndef OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_MESSAGE__STRUCT_HPP_
#define OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_MESSAGE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__open_sound_control_msgs__msg__OscMessage __attribute__((deprecated))
#else
# define DEPRECATED__open_sound_control_msgs__msg__OscMessage __declspec(deprecated)
#endif

namespace open_sound_control_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct OscMessage_
{
  using Type = OscMessage_<ContainerAllocator>;

  explicit OscMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->address = "";
    }
  }

  explicit OscMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : address(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->address = "";
    }
  }

  // field types and members
  using _address_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _address_type address;
  using _types_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _types_type types;
  using _payload_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _payload_type payload;

  // setters for named parameter idiom
  Type & set__address(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->address = _arg;
    return *this;
  }
  Type & set__types(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->types = _arg;
    return *this;
  }
  Type & set__payload(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->payload = _arg;
    return *this;
  }

  // constant declarations
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> FLOAT;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> INTEGER;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> BLOB;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STRING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> TIMETAG;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> IMPULSE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> NIL;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> B_TRUE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> B_FALSE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> CHAR;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> DOUBLE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> MIDI;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> RGBA;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> SYMBOLS;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> ARR_START;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> ARR_STOP;

  // pointer types
  using RawPtr =
    open_sound_control_msgs::msg::OscMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const open_sound_control_msgs::msg::OscMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<open_sound_control_msgs::msg::OscMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<open_sound_control_msgs::msg::OscMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      open_sound_control_msgs::msg::OscMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<open_sound_control_msgs::msg::OscMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      open_sound_control_msgs::msg::OscMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<open_sound_control_msgs::msg::OscMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<open_sound_control_msgs::msg::OscMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<open_sound_control_msgs::msg::OscMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__open_sound_control_msgs__msg__OscMessage
    std::shared_ptr<open_sound_control_msgs::msg::OscMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__open_sound_control_msgs__msg__OscMessage
    std::shared_ptr<open_sound_control_msgs::msg::OscMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const OscMessage_ & other) const
  {
    if (this->address != other.address) {
      return false;
    }
    if (this->types != other.types) {
      return false;
    }
    if (this->payload != other.payload) {
      return false;
    }
    return true;
  }
  bool operator!=(const OscMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct OscMessage_

// alias to use template instance with default allocator
using OscMessage =
  open_sound_control_msgs::msg::OscMessage_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::FLOAT = "f";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::INTEGER = "i";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::BLOB = "b";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::STRING = "s";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::TIMETAG = "t";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::IMPULSE = "I";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::NIL = "N";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::B_TRUE = "T";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::B_FALSE = "F";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::CHAR = "c";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::DOUBLE = "d";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::MIDI = "m";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::RGBA = "r";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::SYMBOLS = "S";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::ARR_START = "[";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
OscMessage_<ContainerAllocator>::ARR_STOP = "]";

}  // namespace msg

}  // namespace open_sound_control_msgs

#endif  // OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_MESSAGE__STRUCT_HPP_
