// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from open_sound_control_msgs:msg/OscBlob.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "open_sound_control_msgs/msg/osc_blob.hpp"


#ifndef OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_BLOB__TRAITS_HPP_
#define OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_BLOB__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "open_sound_control_msgs/msg/detail/osc_blob__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace open_sound_control_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const OscBlob & msg,
  std::ostream & out)
{
  out << "{";
  // member: data
  {
    if (msg.data.size() == 0) {
      out << "data: []";
    } else {
      out << "data: [";
      size_t pending_items = msg.data.size();
      for (auto item : msg.data) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const OscBlob & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const OscBlob & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace open_sound_control_msgs

namespace rosidl_generator_traits
{

[[deprecated("use open_sound_control_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const open_sound_control_msgs::msg::OscBlob & msg,
  std::ostream & out, size_t indentation = 0)
{
  open_sound_control_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use open_sound_control_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const open_sound_control_msgs::msg::OscBlob & msg)
{
  return open_sound_control_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<open_sound_control_msgs::msg::OscBlob>()
{
  return "open_sound_control_msgs::msg::OscBlob";
}

template<>
inline const char * name<open_sound_control_msgs::msg::OscBlob>()
{
  return "open_sound_control_msgs/msg/OscBlob";
}

template<>
struct has_fixed_size<open_sound_control_msgs::msg::OscBlob>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<open_sound_control_msgs::msg::OscBlob>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<open_sound_control_msgs::msg::OscBlob>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_BLOB__TRAITS_HPP_
