// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from open_sound_control_msgs:msg/OscMessage.idl
// generated code does not contain a copyright notice
#include "open_sound_control_msgs/msg/detail/osc_message__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `address`
// Member `types`
#include "rosidl_runtime_c/string_functions.h"
// Member `payload`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
open_sound_control_msgs__msg__OscMessage__init(open_sound_control_msgs__msg__OscMessage * msg)
{
  if (!msg) {
    return false;
  }
  // address
  if (!rosidl_runtime_c__String__init(&msg->address)) {
    open_sound_control_msgs__msg__OscMessage__fini(msg);
    return false;
  }
  // types
  if (!rosidl_runtime_c__String__Sequence__init(&msg->types, 0)) {
    open_sound_control_msgs__msg__OscMessage__fini(msg);
    return false;
  }
  // payload
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->payload, 0)) {
    open_sound_control_msgs__msg__OscMessage__fini(msg);
    return false;
  }
  return true;
}

void
open_sound_control_msgs__msg__OscMessage__fini(open_sound_control_msgs__msg__OscMessage * msg)
{
  if (!msg) {
    return;
  }
  // address
  rosidl_runtime_c__String__fini(&msg->address);
  // types
  rosidl_runtime_c__String__Sequence__fini(&msg->types);
  // payload
  rosidl_runtime_c__uint8__Sequence__fini(&msg->payload);
}

bool
open_sound_control_msgs__msg__OscMessage__are_equal(const open_sound_control_msgs__msg__OscMessage * lhs, const open_sound_control_msgs__msg__OscMessage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // address
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->address), &(rhs->address)))
  {
    return false;
  }
  // types
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->types), &(rhs->types)))
  {
    return false;
  }
  // payload
  if (!rosidl_runtime_c__uint8__Sequence__are_equal(
      &(lhs->payload), &(rhs->payload)))
  {
    return false;
  }
  return true;
}

bool
open_sound_control_msgs__msg__OscMessage__copy(
  const open_sound_control_msgs__msg__OscMessage * input,
  open_sound_control_msgs__msg__OscMessage * output)
{
  if (!input || !output) {
    return false;
  }
  // address
  if (!rosidl_runtime_c__String__copy(
      &(input->address), &(output->address)))
  {
    return false;
  }
  // types
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->types), &(output->types)))
  {
    return false;
  }
  // payload
  if (!rosidl_runtime_c__uint8__Sequence__copy(
      &(input->payload), &(output->payload)))
  {
    return false;
  }
  return true;
}

open_sound_control_msgs__msg__OscMessage *
open_sound_control_msgs__msg__OscMessage__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  open_sound_control_msgs__msg__OscMessage * msg = (open_sound_control_msgs__msg__OscMessage *)allocator.allocate(sizeof(open_sound_control_msgs__msg__OscMessage), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(open_sound_control_msgs__msg__OscMessage));
  bool success = open_sound_control_msgs__msg__OscMessage__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
open_sound_control_msgs__msg__OscMessage__destroy(open_sound_control_msgs__msg__OscMessage * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    open_sound_control_msgs__msg__OscMessage__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
open_sound_control_msgs__msg__OscMessage__Sequence__init(open_sound_control_msgs__msg__OscMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  open_sound_control_msgs__msg__OscMessage * data = NULL;

  if (size) {
    data = (open_sound_control_msgs__msg__OscMessage *)allocator.zero_allocate(size, sizeof(open_sound_control_msgs__msg__OscMessage), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = open_sound_control_msgs__msg__OscMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        open_sound_control_msgs__msg__OscMessage__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
open_sound_control_msgs__msg__OscMessage__Sequence__fini(open_sound_control_msgs__msg__OscMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      open_sound_control_msgs__msg__OscMessage__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

open_sound_control_msgs__msg__OscMessage__Sequence *
open_sound_control_msgs__msg__OscMessage__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  open_sound_control_msgs__msg__OscMessage__Sequence * array = (open_sound_control_msgs__msg__OscMessage__Sequence *)allocator.allocate(sizeof(open_sound_control_msgs__msg__OscMessage__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = open_sound_control_msgs__msg__OscMessage__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
open_sound_control_msgs__msg__OscMessage__Sequence__destroy(open_sound_control_msgs__msg__OscMessage__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    open_sound_control_msgs__msg__OscMessage__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
open_sound_control_msgs__msg__OscMessage__Sequence__are_equal(const open_sound_control_msgs__msg__OscMessage__Sequence * lhs, const open_sound_control_msgs__msg__OscMessage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!open_sound_control_msgs__msg__OscMessage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
open_sound_control_msgs__msg__OscMessage__Sequence__copy(
  const open_sound_control_msgs__msg__OscMessage__Sequence * input,
  open_sound_control_msgs__msg__OscMessage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(open_sound_control_msgs__msg__OscMessage);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    open_sound_control_msgs__msg__OscMessage * data =
      (open_sound_control_msgs__msg__OscMessage *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!open_sound_control_msgs__msg__OscMessage__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          open_sound_control_msgs__msg__OscMessage__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!open_sound_control_msgs__msg__OscMessage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
