// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from open_sound_control_msgs:msg/OscMessage.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "open_sound_control_msgs/msg/osc_message.hpp"


#ifndef OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_MESSAGE__TRAITS_HPP_
#define OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_MESSAGE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "open_sound_control_msgs/msg/detail/osc_message__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace open_sound_control_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const OscMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: address
  {
    out << "address: ";
    rosidl_generator_traits::value_to_yaml(msg.address, out);
    out << ", ";
  }

  // member: types
  {
    if (msg.types.size() == 0) {
      out << "types: []";
    } else {
      out << "types: [";
      size_t pending_items = msg.types.size();
      for (auto item : msg.types) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: payload
  {
    if (msg.payload.size() == 0) {
      out << "payload: []";
    } else {
      out << "payload: [";
      size_t pending_items = msg.payload.size();
      for (auto item : msg.payload) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const OscMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: address
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "address: ";
    rosidl_generator_traits::value_to_yaml(msg.address, out);
    out << "\n";
  }

  // member: types
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.types.size() == 0) {
      out << "types: []\n";
    } else {
      out << "types:\n";
      for (auto item : msg.types) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: payload
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.payload.size() == 0) {
      out << "payload: []\n";
    } else {
      out << "payload:\n";
      for (auto item : msg.payload) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const OscMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace open_sound_control_msgs

namespace rosidl_generator_traits
{

[[deprecated("use open_sound_control_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const open_sound_control_msgs::msg::OscMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  open_sound_control_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use open_sound_control_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const open_sound_control_msgs::msg::OscMessage & msg)
{
  return open_sound_control_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<open_sound_control_msgs::msg::OscMessage>()
{
  return "open_sound_control_msgs::msg::OscMessage";
}

template<>
inline const char * name<open_sound_control_msgs::msg::OscMessage>()
{
  return "open_sound_control_msgs/msg/OscMessage";
}

template<>
struct has_fixed_size<open_sound_control_msgs::msg::OscMessage>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<open_sound_control_msgs::msg::OscMessage>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<open_sound_control_msgs::msg::OscMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OPEN_SOUND_CONTROL_MSGS__MSG__DETAIL__OSC_MESSAGE__TRAITS_HPP_
