// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from open_sound_control_msgs:msg/OscMessage.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "open_sound_control_msgs/msg/detail/osc_message__functions.h"
#include "open_sound_control_msgs/msg/detail/osc_message__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace open_sound_control_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void OscMessage_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) open_sound_control_msgs::msg::OscMessage(_init);
}

void OscMessage_fini_function(void * message_memory)
{
  auto typed_message = static_cast<open_sound_control_msgs::msg::OscMessage *>(message_memory);
  typed_message->~OscMessage();
}

size_t size_function__OscMessage__types(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<std::string> *>(untyped_member);
  return member->size();
}

const void * get_const_function__OscMessage__types(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<std::string> *>(untyped_member);
  return &member[index];
}

void * get_function__OscMessage__types(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<std::string> *>(untyped_member);
  return &member[index];
}

void fetch_function__OscMessage__types(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const std::string *>(
    get_const_function__OscMessage__types(untyped_member, index));
  auto & value = *reinterpret_cast<std::string *>(untyped_value);
  value = item;
}

void assign_function__OscMessage__types(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<std::string *>(
    get_function__OscMessage__types(untyped_member, index));
  const auto & value = *reinterpret_cast<const std::string *>(untyped_value);
  item = value;
}

void resize_function__OscMessage__types(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<std::string> *>(untyped_member);
  member->resize(size);
}

size_t size_function__OscMessage__payload(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<uint8_t> *>(untyped_member);
  return member->size();
}

const void * get_const_function__OscMessage__payload(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<uint8_t> *>(untyped_member);
  return &member[index];
}

void * get_function__OscMessage__payload(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<uint8_t> *>(untyped_member);
  return &member[index];
}

void fetch_function__OscMessage__payload(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const uint8_t *>(
    get_const_function__OscMessage__payload(untyped_member, index));
  auto & value = *reinterpret_cast<uint8_t *>(untyped_value);
  value = item;
}

void assign_function__OscMessage__payload(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<uint8_t *>(
    get_function__OscMessage__payload(untyped_member, index));
  const auto & value = *reinterpret_cast<const uint8_t *>(untyped_value);
  item = value;
}

void resize_function__OscMessage__payload(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<uint8_t> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember OscMessage_message_member_array[3] = {
  {
    "address",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(open_sound_control_msgs::msg::OscMessage, address),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "types",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(open_sound_control_msgs::msg::OscMessage, types),  // bytes offset in struct
    nullptr,  // default value
    size_function__OscMessage__types,  // size() function pointer
    get_const_function__OscMessage__types,  // get_const(index) function pointer
    get_function__OscMessage__types,  // get(index) function pointer
    fetch_function__OscMessage__types,  // fetch(index, &value) function pointer
    assign_function__OscMessage__types,  // assign(index, value) function pointer
    resize_function__OscMessage__types  // resize(index) function pointer
  },
  {
    "payload",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(open_sound_control_msgs::msg::OscMessage, payload),  // bytes offset in struct
    nullptr,  // default value
    size_function__OscMessage__payload,  // size() function pointer
    get_const_function__OscMessage__payload,  // get_const(index) function pointer
    get_function__OscMessage__payload,  // get(index) function pointer
    fetch_function__OscMessage__payload,  // fetch(index, &value) function pointer
    assign_function__OscMessage__payload,  // assign(index, value) function pointer
    resize_function__OscMessage__payload  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers OscMessage_message_members = {
  "open_sound_control_msgs::msg",  // message namespace
  "OscMessage",  // message name
  3,  // number of fields
  sizeof(open_sound_control_msgs::msg::OscMessage),
  false,  // has_any_key_member_
  OscMessage_message_member_array,  // message members
  OscMessage_init_function,  // function to initialize message memory (memory has to be allocated)
  OscMessage_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t OscMessage_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &OscMessage_message_members,
  get_message_typesupport_handle_function,
  &open_sound_control_msgs__msg__OscMessage__get_type_hash,
  &open_sound_control_msgs__msg__OscMessage__get_type_description,
  &open_sound_control_msgs__msg__OscMessage__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace open_sound_control_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<open_sound_control_msgs::msg::OscMessage>()
{
  return &::open_sound_control_msgs::msg::rosidl_typesupport_introspection_cpp::OscMessage_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, open_sound_control_msgs, msg, OscMessage)() {
  return &::open_sound_control_msgs::msg::rosidl_typesupport_introspection_cpp::OscMessage_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
